1000 REMark PLAYABC - v1.01
1010 REMark M.J.Swift - 07 Nov 2024
1020 REMark Supports the most common ABC notation constructs, but not all.
1030 REMark ...and is messier than I had hoped
1040 :
1050 REMark REFERENCES:
1060 :
1070 REMark ABC notation at https://abcnotation.com/wiki/abc:standard:v2.1
1080 REMark Find tunes quickly at https://trillian.mit.edu/~jc/cgi/abc/findtune
1090 REMark Find tunes slowly at https://abcnotation.com/
1100 REMark Online ABC player at https://abc.rectanglered.com/
1110 :
1120 BeepOneSec%=13889:PauseOneSec%=50
1130 KeyOffs%=0:PitchCount%=2:REMark PitchCount%=1 for normal pitch, PitchCount%=2 to bounce between two pitch values.
1140 MaxPit%=1024:DIM PIT$(MaxPit%,3),DuN%(MaxPit%),DuD%(MaxPit%)
1150 DIM Pbeg%(26),Pend%(26)
1160 :
1170 REMark Note to self: Major scale pattern is tone tone semitone tone tone tone semitone
1180 REMark 00----06----12-15----21----27----33-
1190 DIM P%(7):P%(0)=0:P%(1)=6:P%(2)=12:P%(3)=15:P%(4)=21:P%(5)=27:P%(6)=33:P%(7)=36
1200 :
1210 :PtA$="C 4C#4D 4D#4E 4F 4F#4G 4G#4A 4A#4B 4C 5C#5D 5D#5E 5F 5F#5G 5G#5A 5A#5B 5"
1220 :PsA$="B#3Bx3Cx4Eb4Dx4E#4Gb4Fx4Ab4Gx4Bb4Ax4B#4Bx5Cx5Eb5Dx5E#5Gb5Fx5Ab5Gx5Bb5Ax5"
1230 :
1240 :PtB$="C 4Db4D 4Eb4E 4F 4Gb4G 4Ab4A 4Bb4B 4C 5Db5D 5Eb5E 5F 5Gb5G 5Ab5A 5Bb5B 5"
1250 :PsB$="Dz4C#4Ez4D#4Fb4Gz4F#4Az4G#4Bz5A#4Cb5Dz5C#5Ez5D#5Fb5Gz5F#5Az5G#5Bz5A#5Cb5"
1260 :
1270 :PtZ$="C C#DbD EbE F F#GbG AbA BbB "
1280 :
1290 PRINT#0;"Which ABC file?:";:INPUT#0;SrcFileNam$
1300 SrcFileNam$=TOUPPER$(SrcFileNam$)
1310 FnamL%=LEN(SrcFileNam$)
1320 FnamExt$="":IF FnamL%>4 THEN FnamExt$=SrcFileNam$(FnamL%-3 TO)
1330 IF FnamExt$ = "_ABC" THEN
1340  SrcNam$=SrcFileNam$(1 TO FnamL%-4)
1350  ImportABC SrcFileNam$
1360  ExportBAS SrcNam$&"_BAS"
1370  ExportBEEP
1380 END IF
1390 STOP
1400 :
1410 DEFine PROCedure ImportABC(InNam$)
1420  LOCal ABC$,Pos%,Qot%,F$,F,K$,K,FnamL%,FnamExt$,StripDir,FnamP%
1430  LOCal L%,Accidental$,TuneItem$,Octave%,DurNum%,DurDen%,Duration%,Cnote$
1440  REMark get filename without directory and extension
1450  :
1460  OPEN_IN#5;InNam$
1470  OutFmt=0:HeaderFlg%=0
1480  BuildScale "C"
1490  BeatCount%=4:BeatLength%=4
1500  UnitCount%=1:UnitLength%=8:UnitNoteLength=UnitCount%/UnitLength%
1510  TempoBeats%=180:TempoCount%=1:TempoLength%=4
1520  MultipletCounter%=0:MultipletCount%=1:MultipletLength%=1
1530  PitN%=0:P$="A":Pidx%=(CODE(P$)-64)&&31:Pbeg%(Pidx%)=PitN%+1:Pend%(Pidx%)=PitN%
1540  REPeat InLoop
1550   REPeat HeaderLoop
1560    IF EOF(#5) THEN EXIT InLoop
1570    INPUT#5;ABC$:L%=LEN(ABC$):Qot%=0:F=0
1580    Pos%= ":" INSTR ABC$
1590    IF Pos%=2 THEN
1600     REPeat SkipSpaceLoop1
1610      Pos%=Pos%+1:IF Pos%>L% THEN EXIT SkipSpaceLoop1
1620      K$=ABC$(Pos%):K=CODE(K$)
1630      IF K = 34 THEN
1640       Qot%=1-Qot%
1650      ELSE
1660       IF Qot%=0 THEN
1670        IF K <> 32 THEN EXIT SkipSpaceLoop1
1680       END IF
1690      END IF
1700     END REPeat SkipSpaceLoop1
1710     F$=ABC$(1):F=CODE(F$)
1720     SELect ON F
1730      ON F = CODE("M")
1740       BeatCount%=NextN%(ABC$,Pos%)
1750       BeatLength%=NextN%(ABC$,("/" INSTR ABC$)+1)
1760      ON F = CODE("L")
1770       UnitCount%=NextN%(ABC$,Pos%)
1780       UnitLength%=NextN%(ABC$,("/" INSTR ABC$)+1)
1790      ON F = CODE("Q")
1800       TempoCount%=NextN%(ABC$,Pos%)
1810       Pos%=("/" INSTR ABC$)
1820       IF Pos%<>0 THEN
1830        TempoLength%=NextN%(ABC$,("/" INSTR ABC$)+1)
1840        TempoBeats%=NextN%(ABC$,("=" INSTR ABC$)+1)
1850        IF TempoBeats%=1 THEN TempoBeats%=120
1860       ELSE
1870        TempoBeats%=TempoCount%
1880        TempoCount%=UnitCount%
1890        TempoLength%=UnitLength%
1900       END IF
1910      ON F = CODE("P")
1920       IF HeaderFlg%=0 THEN
1930        P$=ABC$(Pos% TO)
1940       ELSE
1950        Pidx%=(CODE(ABC$(Pos%))-64)&&31:Pbeg%(Pidx%)=PitN%+1:Pend%(Pidx%)=PitN%
1960       END IF
1970      ON F = CODE("K")
1980       BuildScale ABC$(Pos% TO)
1990       HeaderFlg%=1
2000      ON F = CODE("A") TO CODE("Z")
2010       REMark ignore other information fields
2020      ON F = CODE("a") TO CODE("z")
2030       REMark ignore other information fields
2040      ON F = REMAINDER
2050       F=0
2060     END SELect
2070     TempoBPM%=((TempoBeats%*UnitLength%*TempoCount%)/(UnitCount%*TempoLength%))
2080    END IF
2090    IF HeaderFlg% = 1 AND F=0 THEN EXIT HeaderLoop
2100   END REPeat HeaderLoop
2110   Pos%=0
2120   REPeat TuneBodyLoop
2130    Qot%=0:Accidental$="":TuneItem$="":Octave%=4+KeyOffs%:Duration%=0:DurNum%=0:DurDen%=0:DurFlg%=0
2140    REPeat TuneItemLoop
2150     REPeat SkipSpaceLoop2
2160      Pos%=Pos%+1:IF Pos%>L% THEN EXIT TuneItemLoop
2170      K$=ABC$(Pos%):K=CODE(K$)
2180      IF K = 34 THEN
2190       Qot%=1-Qot%
2200      ELSE
2210       IF Qot%=0 THEN
2220        IF K <> 32 THEN EXIT SkipSpaceLoop2
2230       END IF
2240      END IF
2250     END REPeat SkipSpaceLoop2
2260     SELect ON K
2270      ON K = CODE(":")
2280       IF TuneItem$="[" OR TuneItem$="]" OR TuneItem$="|" THEN
2290        StackNote "BEG",0,0:TuneItem$=K$
2300       ELSE
2310        IF TuneItem$=":" THEN
2320         StackNote "END",0,0:TuneItem$=K$
2330        ELSE
2340         IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2350         TuneItem$=K$
2360        END IF
2370       END IF
2380      ON K = CODE("["), CODE("]"), CODE("|")
2390       IF TuneItem$=":" THEN
2400        StackNote "END",0,0:TuneItem$=K$
2410       ELSE
2420        IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2430        TuneItem$=K$
2440       END IF
2450      ON K = CODE("_")
2460       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2470       Accidental$="b"
2480      ON K = CODE("=")
2490       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2500       Accidental$=" "
2510      ON K = CODE("^")
2520       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2530       Accidental$="#"
2540      ON K = CODE("A") TO CODE("G")
2550       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2560       TuneItem$=K$:Octave%=4+KeyOffs%
2570      ON K = CODE("a") TO CODE("g")
2580       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2590       TuneItem$=CHR$(K-32):Octave%=5+KeyOffs%
2600      ON K = CODE("x"), CODE("X"), CODE("z"), CODE("Z")
2610       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2620       TuneItem$=K$:Octave%=999
2630      ON K = CODE("(")
2640       IF TuneItem$<>"" THEN Pos%=Pos%-1:EXIT TuneItemLoop
2650       TuneItem$=K$
2660      ON K = CODE(",")
2670       Octave%=Octave%-1
2680      ON K = CODE("'")
2690       Octave%=Octave%+1
2700      ON K = CODE("/")
2710       DurFlg%=1
2720      ON K = CODE("0") TO CODE("9")
2730       IF TuneItem$<>"" THEN
2740        IF DurFlg%=0 THEN
2750         DurNum%=(DurNum%)*10+K-48
2760        ELSE
2770         DurDen%=(DurDen%)*10+K-48
2780        END IF
2790       END IF
2800      ON K = REMAINDER
2810       PRINT#2;K$;
2820     END SELect
2830    END REPeat TuneItemLoop
2840    IF TuneItem$<>"" THEN
2850     IF TuneItem$="[" OR TuneItem$="]" OR TuneItem$="|" THEN
2860      StackNote "BAR",0,0
2870      IF DurNum%<>0 THEN
2880       StackNote "REP",DurNum%,0
2890      END IF
2900     ELSE
2910      IF TuneItem$<>":" THEN
2920     IF DurNum%=0 THEN DurNum%=1
2930     IF DurDen%=0 THEN DurDen%=1
2940     IF TuneItem$="(" THEN
2950      MultipletCount%=DurNum%:MultipletCounter%=MultipletCount%
2960      IF MultipletCount%=2 OR MultipletCount%=4 OR MultipletCount%=8 THEN
2970       MultipletLength%=3
2980      ELSE
2990       IF MultipletCount%=3 OR MultipletCount%=6 THEN
3000        MultipletLength%=2
3010       ELSE
3020        IF BeatCount%=6 OR BeatCount%=9 OR BeatCount%=12 THEN
3030         MultipletLength%=3
3040        ELSE
3050         MultipletLength%=2
3060        END IF
3070       END IF
3080      END IF
3090     ELSE
3100      IF Octave%=999 THEN
3110       IF TuneItem$="x" OR TuneItem$="z" THEN
3120        StackNote "ZZZ",(DurNum%*MultipletLength%),(DurDen%*MultipletCount%)
3130        REMark DoPause (60/TempoBPM%)*((DurNum%*MultipletLength%)/(DurDen%*MultipletCount%))
3140       ELSE
3150        StackNote "ZZZ",(DurNum%*MultipletLength%*BeatCount%*UnitLength%),(DurDen%*MultipletCount%*BeatLength%*UnitCount%)
3160        REMark DoPause (60/TempoBPM%)*((DurNum%*MultipletLength%*BeatCount%*UnitLength%)/(DurDen%*MultipletCount%*BeatLength%*UnitCount%))
3170       END IF
3180      ELSE
3190       IF Accidental$="b" THEN
3200        IF TuneItem$="A" THEN
3210         TuneItem$="G"
3220        ELSE
3230         TuneItem$=CHR$(CODE(TuneItem$)-1)
3240         IF TuneItem$="B" THEN
3250          Octave%=Octave%-1
3260         END IF
3270        END IF
3280        Accidental$="#"
3290       END IF
3300       IF Accidental$="" THEN
3310        Note$=Knote$(TuneItem$&" "&Octave%)
3320       ELSE
3330        Note$=TuneItem$&Accidental$&Octave%
3340       END IF
3350       Cnote$=Knote2Cnote$(Note$)
3360       StackNote Cnote$,(DurNum%*MultipletLength%),(DurDen%*MultipletCount%)
3370       REMark DoCnoteBEEP Cnote$,(60/TempoBPM%)*((DurNum%*MultipletLength%)/(DurDen%*MultipletCount%))
3380      END IF
3390      IF MultipletCounter%>0 THEN MultipletCounter%=MultipletCounter%-1
3400      IF MultipletCounter%=0 THEN MultipletCount%=1:MultipletLength%=1
3410     END IF
3420      END IF
3430     END IF
3440    END IF
3450    IF Pos%>L% THEN EXIT TuneBodyLoop
3460   END REPeat TuneBodyLoop
3470  END REPeat InLoop
3480  CLOSE#5
3490 END DEFine
3500 :
3510 DEFine PROCedure ExportBEEP
3520  OutFmt=0:PlayPart
3530 END DEFine
3540 :
3550 DEFine PROCedure ExportBAS(OutNam$)
3560  DELETE OutNam$
3570  OPEN_NEW#5;OutNam$
3580  LIST#5;10000 TO
3590  LinNum%=10500:LinFlg%=0:LinIdx%=0
3600  OutFmt=CODE("B"):PlayPart
3610  OutBAS "0,0":PRINT#5:CLOSE#5
3620 END DEFine
3630 :
3640 DEFine PROCedure OutBAS(S$)
3650  IF LinIdx%>8 THEN PRINT#5:LinIdx%=0:LinFlg%=0
3660  IF LinFlg%=0 THEN PRINT#5;LinNum%;" DATA ";:LinFlg%=1:LinIdx%=0:LinNum%=LinNum%+1
3670  IF LinIdx%<>0 THEN PRINT#5;",";
3680  PRINT#5;S$;:LinIdx%=LinIdx%+1
3690 END DEFine
3700 :
3710 DEFine FuNction TOUPPER$(S$)
3720  LOCal i,K%
3730  FOR i=1 TO LEN(S$)
3740   K%=CODE(S$(i))
3750   IF K%>=97 AND K%<=122 THEN
3760    S$(i)=CHR$(K%-32)
3770   END IF
3780  END FOR i
3790  RETurn S$
3800 END DEFine
3810 :
3820 DEFine FuNction NextN%(S$,S%)
3830  LOCal N%,K%
3840  N%=0
3850  IF S%>0 THEN
3860   IF S%<=LEN(S$) THEN
3870    K%=CODE(S$(S%))-48
3880    IF K%>=0 AND K%<=9 THEN
3890     N%=N%*10+K%:S%=S%+1:GO TO 3850
3900    END IF
3910   END IF
3920  END IF
3930  IF N%=0 THEN N%=1
3940  RETurn N%
3950 END DEFine
3960 :
3970 DEFine PROCedure StackNote(N$,durN%,durD%)
3980  PitN%=PitN%+1:Pend%(Pidx%)=PitN%
3990  PIT$(PitN%)=N$:DuN%(PitN%)=durN%:DuD%(PitN%)=durD%
4000  REMark PRINT PitN%;":";N$;",";durN%;"/";durD%
4010 END DEFine
4020 :
4030 DEFine PROCedure PlayPart
4040  LOCal i,Pidx%,b%,e%
4050  FOR i=1 TO LEN(P$)
4060   Pidx%=(CODE(P$(i))-64)&&31:b%=Pbeg%(Pidx%):e%=Pend%(Pidx%)
4070   PlayStack b%,e%
4080  END FOR i
4090 END DEFine
4100 :
4110 DEFine PROCedure PlayStack(b%,e%)
4120  LOCal i%,PlayLoop,N$,durN%,durD%,BP%
4130  i%=b%:CommonBeg%=i%:RepCount%=1:OutFlg%=1
4140  REPeat PlayLoop
4150   IF i%>e% THEN EXIT PlayLoop
4160   N$=PIT$(i%):durN%=DuN%(i%):durD%=DuD%(i%)
4170   REMark PRINT N$;",";durN%;"/";durD%
4180   IF N$="BAR" THEN
4190    REMark Do bars
4200   ELSE
4210    IF N$="BEG" THEN
4220     REMark set common section begin
4230    ELSE
4240     IF N$="END" THEN
4250      REMark end repeated section
4260      IF OutFlg%=1 THEN
4270       RepCount%=RepCount%+1
4280       i%=CommonBeg%
4290      END IF
4300     ELSE
4310      IF N$="REP" THEN
4320       REMark begin repeated section
4330       RepIdx%=durN%
4340       IF RepIdx%=RepCount%
4350        OutFlg%=1
4360       ELSE
4370        OutFlg%=0
4380       END IF
4390      ELSE
4400       IF OutFlg%=1 THEN
4410        IF N$="ZZZ" THEN
4420         DoPause (60/TempoBPM%)*(durN%/durD%)
4430        ELSE
4440         DoCnoteBEEP N$,(60/TempoBPM%)*(durN%/durD%)
4450        END IF
4460       END IF
4470      END IF
4480     END IF
4490    END IF
4500   END IF
4510   i%=i%+1
4520  END REPeat PlayLoop
4530 END DEFine
4540 :
4550 DEFine PROCedure DoPause(dur)
4560  LOCal BP%,durP%
4570  durP%=PauseOneSec%*dur
4580  SELect ON OutFmt
4590   ON OutFmt = CODE("B")
4600    OutBAS "-1,"&durP%
4610   ON OutFmt = REMAINDER
4620    BP%=BEEPING:IF BP% THEN GO TO 4620
4630    PRINT "REST"
4640    PAUSE durP%
4650  END SELect
4660 END DEFine
4670 :
4680 DEFine PROCedure DoCnoteBEEP(Note$,dur)
4690  LOCal BP%,pitch%,pitch1%,pitch2%,dur%,durB,durP%
4700  pitch%=Cnote2Pitch%(Note$)
4710  durB=BeepOneSec%*dur
4720  durP%=PauseOneSec%*dur
4730  SELect ON OutFmt
4740   ON OutFmt = CODE("B")
4750    OutBAS pitch%&","&INT(durB)
4760   ON OutFmt = REMAINDER
4770    BP%=BEEPING:IF BP% THEN GO TO 4770
4780    PRINT Note$
4790    IF durB<32768 THEN dur%=durB:ELSE dur%=0:END IF
4800    IF pitch%<255 THEN
4810     BEEP dur%,pitch%
4820    ELSE
4830     pitch2%=INT(pitch%/256):pitch1%=pitch%-256*pitch2%
4840     BEEP dur%,pitch1%,pitch2%,3,pitch2%-pitch1%
4850    END IF
4860    BP%=BEEPING:IF BP%=0 THEN dur%=0
4870    IF dur%=0 THEN
4880     PAUSE durP%:BEEP
4890    END IF
4900  END SELect
4910 END DEFine
4920 :
4930 DEFine FuNction Cnote2Pitch%(Cnote$)
4940  LOCal pitch,pitch1%,pitch2%
4950  pitch=INT(PitchCount%*(11447/((55*2^(Cnote$(3)-1))*(EXP(LN(2)*((Cnote$(1 TO 2)INSTR"C C#D D#E F F#G G#A A#B "-19)/2)/12)))-10.6)+.5)/PitchCount%
4960  pitch1%=INT(pitch):pitch2%=-INT(-pitch)
4970  IF pitch1%=pitch2% THEN
4980   RETurn pitch1%
4990  ELSE
5000   RETurn pitch1%+(pitch2%*256)
5010  END IF
5020 END DEFine
5030 :
5040 DEFine FuNction Knote2Cnote$(Note$)
5050  LOCal Pos%,Acci$,Octv%,Cnote$
5060  Pos%=Note$(1)INSTR PtA$
5070  Acci$=Note$(2):Octv%=Note$(3)
5080  IF Acci$="#" THEN
5090   Pos%=Pos%+3
5100  ELSE
5110   IF Acci$="x" THEN
5120    Pos%=Pos%+6
5130   ELSE
5140    IF Acci$="b" THEN
5150     Pos%=Pos%-3
5160    ELSE
5170     IF Acci$="z" THEN
5180      Pos%=Pos%-6
5190     END IF
5200    END IF
5210   END IF
5220  END IF
5230  IF Pos%<1 THEN Pos%=Pos%+36:Octv%=Octv%-1
5240  IF Pos%>36 THEN Pos%=Pos%-36:Octv%=Octv%+1
5250  Cnote$=PtA$(Pos% TO Pos%+1)&Octv%
5260  RETurn Cnote$
5270 END DEFine
5280 :
5290 DEFine FuNction Knote$(Note$)
5300  LOCal Pos%,Octv%
5310  Pos%=Note$(1)INSTR KeyScale$
5320  Octv%=Note$(3)+KeyScale$(Pos%+2)-4
5330  Octv%=Note$(3)
5340  RETurn KeyScale$(Pos% TO Pos%+1)&Octv%
5350 END DEFine
5360 :
5370 DEFine PROCedure BuildMajorScale(KeyOf$)
5380  LOCal Pt$,Ps$,Kidx%,i,idx%,Note$,N$
5390  KeyScale$=""
5400  Pt$=PtA$:Ps$=PsA$
5410  Kidx%=KeyOf$ INSTR Pt$
5420  IF Kidx%=0 THEN
5430   Pt$=PtB$:Ps$=PsB$
5440   Kidx%=KeyOf$ INSTR Pt$
5450  END IF
5460  N$=KeyOf$(1)
5470  FOR i=0 TO 7
5480   idx%=Kidx%+P%(i)
5490   Note$=Pt$(idx% TO idx%+2)
5500   IF Note$(1)<>N$ THEN
5510    Note$=Ps$(idx% TO idx%+2)
5520   END IF
5530   KeyScale$=KeyScale$&Note$
5540   N$=CHR$(CODE(N$)+1):IF N$="H" THEN N$="A"
5550  END FOR i
5560 END DEFine
5570 :
5580 DEFine PROCedure BuildScale(KeyOf$)
5590  LOCal Pos%,KeyNote$,KeyMode$,KeyMode%,K$,K,j,KeyN$
5600  Pos%=1
5610  IF LEN(KeyOf$)>1 THEN
5620   IF KeyOf$(2)="#" OR KeyOf$(2)="b" THEN
5630    Pos%=2
5640   END IF
5650  END IF
5660  KeyNote$=KeyOf$(1 TO Pos%):KeyNote$=KeyNote$&" ":KeyNote$=KeyNote$(1 TO 2)
5670  KeyMode$=""
5680  Pos%=Pos%+1
5690  IF Pos%<LEN(KeyOf$) THEN
5700   IF KeyOf$(Pos%)=" " THEN GO TO 5680
5710  END IF
5720  GO TO 5800
5730  K$=KeyOf$(Pos%):K=CODE(K$)
5740  IF K>=97 AND K<=122 THEN
5750   K=K-32:K$=CHR$(K)
5760  END IF
5770  KeyMode$=KeyMode$&K$
5780  IF LEN(KeyMode$)=3 THEN GO TO 5810
5790  Pos%=Pos%+1
5800  IF Pos%<=LEN(KeyOf$) THEN GO TO 5730
5810  IF KeyMode$="" THEN KeyMode$="MAJ"
5820  IF KeyMode$="M" THEN KeyMode$="MIN"
5830  REMark PRINT KeyNote$,KeyMode$
5840  IF KeyMode$="MAJ" THEN KeyMode%=0
5850  IF KeyMode$="DOR" THEN KeyMode%=1
5860  IF KeyMode$="PHR" THEN KeyMode%=2
5870  IF KeyMode$="LYD" THEN KeyMode%=3
5880  IF KeyMode$="MIX" THEN KeyMode%=4
5890  IF KeyMode$="MIN" THEN KeyMode%=5
5900  IF KeyMode$="LOC" THEN KeyMode%=6
5910  FOR j=1 TO LEN (PtZ$)-1 STEP 2
5920   KeyN$=PtZ$(j TO j+1):KeyN$=KeyN$&" ":KeyN$=KeyN$(1 TO 2)
5930   BuildMajorScale(KeyN$)
5940   IF KeyScale$(KeyMode%*3+1 TO KeyMode%*3+2)=KeyNote$ THEN GO TO 5960
5950  END FOR j
5960  REMark PRINT KeyScale$
5970 END DEFine
5980 :
10000 :
10010 REMark PLAYABC export - v1.01 - M.J.Swift - 07 Nov 2024
10020 :
10030 PauseGap%=0:REMark Increase to get a staccato rhythm
10040 PauseOneSec%=50:BeepOneSec%=13889
10050 BeepGap%=((BeepOneSec%*PauseGap%)/PauseOneSec%+.5)
10060 RESTORE 10500
10070 REPeat loop
10080  OUTnote
10090  IF dur=0 THEN EXIT loop
10100  REMark Do stuff while it's beeping
10110 END REPeat loop
10120 STOP
10130 :
10140 DEFine PROCedure OUTnote
10150  LOCal BP%,pitch%,pitch1%,pitch2%,durB%,durP%
10160  BP%=BEEPING
10170  IF NOT BP% THEN
10180   READ pitch%,dur
10190   IF dur=0 THEN
10200    RESTORE 10500
10210   ELSE
10220    IF PauseGap%<>0 THEN
10230     PAUSE PauseGap%
10240    END IF
10250    IF pitch%<0 THEN
10260     PAUSE (dur-PauseGap%)
10270    ELSE
10280     IF dur<32768 THEN durB%=(dur-BeepGap%):durP%=0:ELSE durP%=((dur*PauseOneSec%)/BeepOneSec%-PauseGap%):durB%=0:END IF
10290     IF pitch%<255 THEN
10300      BEEP durB%,pitch%
10310     ELSE
10320      pitch2%=INT(pitch%/256):pitch1%=pitch%-256*pitch2%
10330      BEEP durB%,pitch1%,pitch2%,3,pitch2%-pitch1%
10340     END IF
10350     BP%=BEEPING:IF BP%=0 THEN durP%=(dur*PauseOneSec%)/BeepOneSec%
10360     IF durP%<>0 THEN
10370      PAUSE durP%:BEEP
10380     END IF
10390    END IF
10400   END IF
10410  END IF
10420 END DEFine
10430 :
